//+------------------------------------------------------------------+
//|                                      ERGODIC_IGR_COL.mq4         |
//+------------------------------------------------------------------+
#property  copyright "AHGDP"
#property  link      "ERGODIC_IGR"

#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  DodgerBlue
#property indicator_width1 2
#property  indicator_color2  Red
#property indicator_width2 2

#property indicator_level1 370
#property indicator_level2 0
#property indicator_level3 -370
#property indicator_levelcolor Gold

extern int  pu          = 8 ;
extern int  ps          = 5 ;
extern int  pr          = 1 ;
extern int  psm         = 5 ;
extern int  MA_Method   = 0 ;

extern int  LineSize  = 2 ;
extern int  CountBars = 1000 ; 

double ErgoCCI[];
double MainCCI[];
double mtm[];
double absmtm[];
double var1[];
double var2[];
double var2a[];
double var2b[];

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init()
  { IndicatorDigits(+0); 
    IndicatorBuffers(8);
    SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,LineSize);
    SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,LineSize);
    SetIndexBuffer(0,ErgoCCI);
    SetIndexBuffer(1,MainCCI);
    SetIndexBuffer(2,mtm);
    SetIndexBuffer(3,absmtm);
    SetIndexBuffer(4,var1);
    SetIndexBuffer(5,var2);
    SetIndexBuffer(6,var2a);
    SetIndexBuffer(7,var2b);
//=========================================================      
       string  ThisName = "ERGODIC_IGR";
       string Text=ThisName;
       Text=Text+"( ";
       Text=Text+" "+DoubleToStr(pu,0);
       Text=Text+", "+DoubleToStr(ps,0);
       Text=Text+", "+DoubleToStr(pr,0);
       Text=Text+", "+DoubleToStr(psm,0);
       Text=Text+")  ";
       IndicatorShortName(Text);
//=======================================================
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  {
      SetIndexDrawBegin(0,Bars-CountBars);
      SetIndexDrawBegin(1,Bars-CountBars);
   int limit;
   int i;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
 
//---- main loop

   for(i=limit; i >= 0; i--) 
   {
   mtm[i]= Close[i]- Close[i +1];
   }
   for(i=limit; i >= 0; i--) 
   { 
    absmtm[i] =  MathAbs(mtm[i]);
   }
   for(i=limit; i >= 0; i--) 
   {   
    var1[i]= iMAOnArray(mtm,0,pr,0,MODE_EMA,i);
   }
   for(i=limit; i >= 0; i--) 
   {
   var2[i]= iMAOnArray(var1,0,pu,0,MODE_EMA,i);
   }
   for(i=limit; i >= 0; i--) 
   {
   var2a[i]= iMAOnArray(absmtm,0,pr,0,MODE_EMA,i);
   }
   for(i=limit; i >= 0; i--) 
   {
   var2b[i]= iMAOnArray(var2a,0,pu,0,MODE_EMA,i);
   }
    for(i=limit; i >= 0; i--) 
   {   
   if(iMAOnArray(var2b,0,ps,0,MODE_EMA,i)!=0)
   ErgoCCI[i] = (500 * iMAOnArray(var2,0,ps,0,MODE_EMA,i))/(iMAOnArray(var2b,0,ps,0,MODE_EMA,i)); 
   
   }
//======================= buf 5/6 COLOR CODE dyn =====================================================================  
for(i=limit; i>=0; i--)
   {   MainCCI[i] = EMPTY_VALUE;
      
      if   (  ErgoCCI[i + 1] <  ErgoCCI[i] )  {MainCCI[i + 1] = MainCCI[i + 1];
                                               MainCCI[i] = MainCCI[i];
           }
     else 
          {  if  ( ErgoCCI[i + 1] >  ErgoCCI[i])
                 {   if (MainCCI[i + 1] == EMPTY_VALUE) MainCCI[i + 1] =  ErgoCCI[i + 1];
                                                         MainCCI[i] =  ErgoCCI[i];
   }      }      }      
   
 //  for(i=limit; i>=0; i--)
 //  {
 //    MainCCI[i]=iMAOnArray(ErgoCCI,0,psm,0,MA_Method,i);
 //  }
  
   return(0);
    
  }
//+------------------------------------------------------------------+

